"use strict";
const _ = require("lodash");
class EvaluationProfiler {
    constructor() {
        this.times = [];
    }
    average(input) {
        const instances = this.times.filter(data => data.input === input);
        return _.reduce(instances, (res, data) => res + data.delta) / instances.length;
    }
    start() {
        const profiler = this;
        return new class {
            evaluate(input) {
                profiler.startTime = Date.now();
                return input;
            }
        }
        ;
    }
    end() {
        const profiler = this;
        return new class {
            evaluate(input) {
                const endTime = Date.now();
                profiler.times.push({
                    delta: endTime - profiler.startTime,
                    input: profiler.currentInput
                });
                return input;
            }
        }
        ;
    }
}
exports.EvaluationProfiler = EvaluationProfiler;
